diff --git a/philosophy/surveillance-vs-democracy.pt-br.po b/philosophy/surveillance-vs-democracy.pt-br.po
index 9c5ba4f..5d9bb56 100644
--- a/philosophy/surveillance-vs-democracy.pt-br.po
+++ b/philosophy/surveillance-vs-democracy.pt-br.po
@@ -7,7 +7,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: surveillance-vs-democracy.html\n"
 "POT-Creation-Date: 2017-11-09 19:26+0000\n"
-"PO-Revision-Date: 2017-05-20 16:20-0300\n"
+"PO-Revision-Date: 2017-11-18 18:32-0200\n"
 "Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
 "Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
@@ -16,6 +16,7 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 "X-Generator: Virtaal 1.0.0-beta1\n"
+"X-Outdated-Since: 2017-11-09 19:26+0000\n"
 
 #. type: Content of: <title>
 msgid ""
@@ -432,24 +433,6 @@ msgstr ""
 "libre em seu próprio computadores antes de enviá-lo."
 
 #. type: Content of: <div><div><p>
-# | For privacy's sake, you must avoid nonfree software since, as a
-# | consequence of giving others control of your computing, it is <a
-# | [-href=\"/philosophy/proprietary-surveillance.html\">likely-]
-# | {+href=\"/malware/proprietary-surveillance.html\">likely+} to spy on
-# | you</a>.  Avoid <a
-# | href=\"/philosophy/who-does-that-server-really-serve.html\">service as a
-# | software substitute</a>; [-as well as-] {+in addition to+} giving others
-# | control of {+how+} your [-computing,-] {+computing is done,+} it requires
-# | you to hand over all the pertinent data to the server.
-#, fuzzy
-#| msgid ""
-#| "For privacy's sake, you must avoid nonfree software since, as a "
-#| "consequence of giving others control of your computing, it is <a href=\"/"
-#| "philosophy/proprietary-surveillance.html\">likely to spy on you</a>.  "
-#| "Avoid <a href=\"/philosophy/who-does-that-server-really-serve.html"
-#| "\">service as a software substitute</a>; as well as giving others control "
-#| "of your computing, it requires you to hand over all the pertinent data to "
-#| "the server."
 msgid ""
 "For privacy's sake, you must avoid nonfree software since, as a consequence "
 "of giving others control of your computing, it is <a href=\"/malware/"
@@ -460,9 +443,9 @@ msgid ""
 msgstr ""
 "Por uma questão de privacidade, você deve evitar softwares não livres já "
 "que, como uma consequência de dar a outros o controle de seu computador, "
-"isto <a href=\"/philosophy/proprietary-surveillance.html\">possibilita lhe "
+"isto <a href=\"/malware/proprietary-surveillance.html\">possibilita lhe "
 "espiar</a>. Evite <a href=\"/philosophy/who-does-that-server-really-serve."
-"html\">serviços como um substituto de softwares</a>; assim como fornecer a "
+"html\">serviços como um substituto de softwares</a>; além de fornecer a "
 "outros o controle de seu computador, isso requer que você entregue todos os "
 "dados pertinentes do servidor."
 
+"PO-Revision-Date: 2017-11-18 18:32-0200\n"
+André Phellip <werewolf@cyberdude.com>\n"
@@ 65 - 84 @@ 
 msgid ""
 "Thanks to Edward Snowden's disclosures, we know that the current level of "
 "general surveillance in society is incompatible with human rights.  The "
 "repeated harassment and prosecution of dissidents, sources, and journalists "
 "in the US and elsewhere provides confirmation.  We need to reduce the level "
 "of general surveillance, but how far? Where exactly is the <em>maximum "
 "tolerable level of surveillance</em>, which we must ensure is not exceeded? "
 "It is the level beyond which surveillance starts to interfere with the "
 "functioning of democracy, in that whistleblowers (such as Snowden) are "
 "likely to be caught."
 msgstr ""
 "Graças às revelações de Edward Snowden, sabemos que o nível atual de "
 "vigilância geral na sociedade é incompatível com os direitos humanos. A "
-"atual perseguição e acusação de dissidentes, fontes e jornalistas nos EUA e "
+"repetida perseguição e acusação de dissidentes, fontes e jornalistas nos EUA e "
 "em outros lugares fornece a confirmação. Precisamos reduzir o nível geral de "
 "vigilância, mas quanto? Qual exatamente é o <em>nível máximo de tolerância "
 "de vigilância</em>, que devemos garantir que não seja excedido? É o nível "
 "acima do qual a vigilância começa a interferir com o funcionamento da "
 "democracia, na medida em que os denunciantes (como Snowden) são suscetíveis "
 "de ser aprisionados."

@@ 87 - 100 @@ 

 msgid ""
 "Faced with government secrecy, we the people depend on whistleblowers to <a "
 "href=\"https://www.eff.org/deeplinks/2013/11/reddit-tpp-ama\">tell us what "
 "the state is doing</a>.  However, today's surveillance intimidates potential "
 "whistleblowers, which means it is too much.  To recover our democratic "
 "control over the state, we must reduce surveillance to the point where "
 "whistleblowers know they are safe."
 msgstr ""
 "Defrontados com segredos do governo, nós - o povo - dependemos de "
 "denunciantes para <a href=\"https://www.eff.org/deeplinks/2013/11/reddit-tpp-"
-"ama\">nos dizer o que o estado está fazendo</a>. Porém, a vigilância dos "
+"ama\">nos dizer o que o estado está fazendo</a>. Todavia, a vigilância dos "
-"dias atuais intimida potenciais denunciantes, o que significa que são "
+"dias atuais intimida potenciais denunciantes, o que significa que é demais. "
 Para recuperar nosso controle democrático sobre o estado, devemos "
-"reduzir a vigilância ao ponto que denunciantes saibam que estarão seguros."
+"reduzir a vigilância ao ponto em que denunciantes saibam que estarão seguros."

@@ 131 - 145 @@ 

 msgid ""
 "<a href=\"http://www.theguardian.com/world/2013/oct/10/nsa-surveillance-"
 "patriot-act-author-bill\">Bipartisan legislation to &ldquo;curtail the "
 "domestic surveillance powers&rdquo;</a> in the U.S. is being drawn up, but "
 "it relies on limiting the government's use of our virtual dossiers.  That "
 "won't suffice to protect whistleblowers if &ldquo;catching the "
 "whistleblower&rdquo; is grounds for access sufficient to identify him or "
 "her.  We need to go further."
 msgstr ""
 "<a href=\"http://www.theguardian.com/world/2013/oct/10/nsa-surveillance-"
-"patriot-act-author-bill\">Uma legislação suprapartidária para “reduzir os "
+"patriot-act-author-bill\">Uma legislação bipartidária para “restrigir os "
-"poderes de vigilância doméstica nos EUA”</a> está sendo elaborada, mas não "
+"poderes de vigilância doméstica nos EUA”</a> está sendo elaborada, mas "
-"estabelece o limite de acesso de nossos dossiês virtuais pelo governo. Isso "
+"depende da limitação do uso do governo de nossos dossiês virtuais. Isso "
 "não será suficiente para proteger denunciantes, se “pegar os denunciantes” é "
-"motivo suficiente para identificá-lo ou identificá-la. Necessitamos ir além."
+"motivo suficiente para identificá-lo(a). Necessitamos ir além."

@@ 152 - 162 @@ 

 msgid ""
 "If whistleblowers don't dare reveal crimes and lies, we lose the last shred "
 "of effective control over our government and institutions.  That's why "
 "surveillance that enables the state to find out who has talked with a "
 "reporter is too much surveillance&mdash;too much for democracy to endure."
 msgstr ""
 "Se denunciantes não ousarem revelar crimes e mentiras, perderemos o último "
-"pedaço de controle efetivo sobre nosso governo e instituições. Por essa "
+"pedaço de controle efetivo sobre nosso governo e instituições. É por isso "
-"razão, a vigilância que permite ao Estado identificar quem se comunicou com "
+"que a vigilância que permite ao Estado identificar quem se comunicou com "
-"um jornalista é vigilância demais, uma vigilância que a democracia não pode "
+"um jornalista é vigilância demais - demais para uma democracia suportar. "

@@ 279 - 281 @@

-"uma obsessão romântica</a>. A AP sabe de <a href=\"http://bigstory.ap.org/"
+"uma obsessão romântica</a>. A Associated Press sabe de <a href=\"http://bigstory.ap.org/"

@@ 343 - 351 @@

 msgid ""
 "The Electronic Frontier Foundation and other organizations propose a set of "
 ...
 msgstr ""
-"A Electronic Frontier Foundation ou outras organizações propõem um conjunto "
+"A Electronic Frontier Foundation e outras organizações propõem um conjunto "
 ...
 
@@ 382 - 401 @@

 msgid ""
 "If limits on access to the data are set aside, it will be as if they had "
 "never existed: years worth of dossiers would suddenly become available for "
 "misuse by the state and its agents and, if collected by companies, for their "
 "private misuse as well.  If, however, we stop the collection of dossiers on "
 "everyone, those dossiers won't exist, and there will be no way to compile "
 "them retroactively.  A new illiberal regime would have to implement "
 "surveillance afresh, and it would only collect data starting at that date.  "
 "As for suspending or momentarily ignoring this law, the idea would hardly "
 "make sense."
 msgstr ""
-"Se limites de acesso aos dados fossem deixados de lado, será como se tais "
+"Se limites de acesso aos dados forem deixados de lado, será como se tais "
-"limites nem tivessem existidos: anos de dossiês de repente passariam a estar "
+"limites nunca tivessem existido: anos de dossiês de repente passariam a estar "
 "disponíveis para mau uso pelo Estado e seus agentes e, se coletado por "
-"empresas, também para mau uso privados. Se, porém, nós pararmos a coleta de "
+"empresas, também para mau uso privados. Se, entretanto, nós pararmos a coleta de "
-"dossiês de todos, aqueles dossiês não existiriam e, portanto, não haveria "
+"dossiês de todos, aqueles dossiês não existirão e, portanto, não haverá "
 "uma forma de compilá-los retroativamente. Uma novo regime iliberal teria que "
 "implementar uma vigilância nova, e coletaria apenas dados a partir daquela "
 "data. Quanto a suspender ou momentaneamente ignorar essa lei, a ideia "
 "dificilmente faria sentido."

@@ 436 - 450 @@ 

 msgid ""
 "For privacy's sake, you must avoid nonfree software since, as a consequence "
 "of giving others control of your computing, it is <a href=\"/malware/"
 "proprietary-surveillance.html\">likely to spy on you</a>.  Avoid <a href=\"/"
 "philosophy/who-does-that-server-really-serve.html\">service as a software "
 "substitute</a>; in addition to giving others control of how your computing "
 "is done, it requires you to hand over all the pertinent data to the server."
 msgstr ""
-"Por uma questão de privacidade, você deve evitar softwares não livres já "
+"Pelo bem da privacidade, você deve evitar softwares não livres já "
 "que, como uma consequência de dar a outros o controle de seu computador, "
 "isto <a href=\"/malware/proprietary-surveillance.html\">possibilita lhe "
 "espiar</a>. Evite <a href=\"/philosophy/who-does-that-server-really-serve."
 "html\">serviços como um substituto de softwares</a>; além de fornecer a "
 "outros o controle de seu computador, isso requer que você entregue todos os "
 "dados pertinentes do servidor."
 
@@ 453 - 472 @@

 msgid ""
 "Protect your friends' and acquaintances' privacy, too.  <a href=\"http://"
 "bits.blogs.nytimes.com/2014/05/21/in-cybersecurity-sometimes-the-weakest-"
 "link-is-a-family-member/\">Don't give out their personal information</a> "
 "except how to contact them, and never give any web site your list of email "
 "or phone contacts.  Don't tell a company such as Facebook anything about "
 "your friends that they might not wish to publish in a newspaper.  Better "
 "yet, don't be used by Facebook at all.  Reject communication systems that "
 "require users to give their real names, even if you are going to give yours, "
 "since they pressure other people to surrender their privacy."
 msgstr ""
 "Proteja a privacidade de seus amigos e conhecidos também. <a href=\"http://"
 "bits.blogs.nytimes.com/2014/05/21/in-cybersecurity-sometimes-the-weakest-"
-"link-is-a-family-member/\">Não forneça informação pessoal deles</a>, exceto "
+"link-is-a-family-member/\">Não forneça informações pessoais deles</a>, exceto "
 "como contatá-los, e nunca forneça a qualquer site sua lista de contatos de e-"
 "mail e de telefones. Não informe a uma empresa, como o Facebook, nada sobre "
-"seus amigos que eles podem não desejar ser divulgado em um jornal. Melhor "
+"seus amigos que eles não desejassem ver publicado em um jornal. Melhor "
 "ainda, não use o Facebook. Rejeite sistemas de comunicação que exigem que os "
 "usuários forneça seus nomes reais, mesmo se você vai informar o seu, já que "
 "eles pressionam outras pessoas a abrir mão de sua privacidade."
 
@@ 578 - 598 @@

 msgid ""
 "Internet-connected cameras often have lousy digital security themselves, "
 "which means <a href=\"http://www.networkworld.com/community/blog/cia-wants-"
 "spy-you-through-your-appliances\">anyone can watch what those cameras see</"
 "a>.  This makes internet-connected cameras a major threat to security as "
 "well as privacy.  For privacy's sake, we should ban the use of Internet-"
 "connected cameras aimed where and when the public is admitted, except when "
 "carried by people.  Everyone must be free to post photos and video "
 "recordings occasionally, but the systematic accumulation of such data on the "
 "Internet must be limited."
 msgstr ""
-"Câmeras conectadas à Internet geralmente possuem uma segurança digital "
+"Câmeras conectadas à internet geralmente possuem uma segurança digital "
 "péssima, o que significa que <a href=\"http://www.networkworld.com/community/"
 "blog/cia-wants-spy-you-through-your-appliances\">qualquer um pode assistir o "
-"que aquelas câmeras veem</a>. Isso torna as câmeras conectadas à Internet "
+"que aquelas câmeras vêem</a>. Isso torna as câmeras conectadas à internet "
-"uma ameaça ainda maior à segurança, assim como à privacidade. Por uma "
+"uma ameaça ainda maior à segurança, assim como à privacidade. Pelo bem "
-"questão de privacidade, nós deveríamos banir o uso de câmeras conectadas à "
+"da privacidade, nós deveríamos banir o uso de câmeras conectadas à "
-"Internet onde e quando o público é admitido, exceto quando carregado por "
+"internet onde e quando o público é admitido, exceto quando administrado por "
-"pessoas. Todo mundo deveria ser livre para publicar fotos e gravações de "
+"pessoas. Todo mundo deve ser livre para publicar fotos e gravações de "
 "vídeo ocasionalmente, mas a acumulação sistemática de tais dados na Internet "
 "deve ser limitada."
 
@@ 617 - 624 @@

 msgid ""
 "Most data collection comes from people's own digital activities.  Usually "
 ...
 msgstr ""
-"A maioria dos dados coletados vêm das atividades digital das próprias "
+"A maioria dos dados coletados vem das atividades digital das próprias "
 ...

@@ 632 - 652 @@

 msgid ""
 ...
 "phone-trove-eclipsing-nsas.html?_r=0\">makes them available to the DEA</a> "
 ...
 "many of those companies misuse the data directly or provide it to data "
 "brokers."
 
 msgstr ""
 ...
-"html?_r=0\">disponibiliza para o DEA</a> para pesquisa sob demanda. "
+"html?_r=0\">disponibiliza para o DEA (Administração de Fiscalização"
+" de Drogas</a> para pesquisa sob demanda. "
 ...
-"ou os fornecem para <i>data brokers“</i><sup><a href=\"#TransNote3\">3</a></"
+"ou os fornecem para <i>"corretores de dados“</i> "
...

@@ 733 - 743 @@

 msgid ""
 "A further threat from sites' collection of personal data is that security "
 "breakers might get in, take it, and misuse it.  This includes customers' "
 "credit card details.  An anonymous payment system would end this danger: a "
 "security hole in the site can't hurt you if the site knows nothing about you."
 msgstr ""
 "Uma ameaça ainda maior da coleção de dados pessoais dos sites é que crackers "
 "podem quebrar a segurança e acessar, tomar e fazer mau uso deles. Isso "
-"também inclui detalhes de cartão de crédito dos consumidores. Qualquer "
+"também inclui detalhes de cartão de crédito dos consumidores. Um "
 "sistema de pagamento anônimo daria fim a esse perigo: um buraco de "
-"segurança em um site não pode machucar se o site sabe nada sobre você."
+"segurança em um site não pode te machucar se o site não sabe nada sobre você."

@@ 800 - 813 @@

 msgid ""
 "Many mass transit systems use some kind of smart cards or RFIDs for "
 "payment.  These systems accumulate personal data: if you once make the "
 "mistake of paying with anything but cash, they associate the card "
 "permanently with your name.  Furthermore, they record all travel associated "
 "with each card.  Together they amount to massive surveillance.  This data "
 "collection must be reduced."
 msgstr ""
 "Muitos sistemas de trânsito em massa usam alguns tipos de cartões "
-"inteligentes ou RFIDs para pagamento. Esses sistemas acumulam dados "
+"inteligentes ou RFIDs (Identificação por radiofrequência) para pagamento. Esses sistemas acumulam dados "
-"pessoais: se você alguma vez você cometer o erro de pagar com qualquer outra "
+"pessoais: se alguma vez você cometer o erro de pagar com qualquer outra "
 "coisa além de dinheiro, eles associam o cartão permanentemente a seu nome. "
 "Além disso, eles registram todas as viagens associadas a cada cartão. "
 "Juntando tudo, eles acumulam muito para a vigilância massiva. A coleta "
 "desses dados deve ser reduzida."

@@ 816 - 836 @@

 msgid ""
 "Navigation services do surveillance: the user's computer tells the map "
 "service the user's location and where the user wants to go; then the server "
 "determines the route and sends it back to the user's computer, which "
 "displays it.  Nowadays, the server probably records the user's locations, "
 "since there is nothing to prevent it.  This surveillance is not inherently "
 "necessary, and redesign could avoid it: free/libre software in the user's "
 "computer could download map data for the pertinent regions (if not "
 "downloaded previously), compute the route, and display it, without ever "
 "telling anyone where the user is or wants to go."
 msgstr ""
 "Serviços de navegação fazem vigilância: o computador do usuário informa ao "
 "serviço de mapa a localização do usuário e onde ele deseja ir; então, o "
 "servidor determina a rota e envia-a de volta para o computador do usuário, o "
-"que exibe-a. Hoje em dia, o servidor provavelmente registra as localizações "
+"qual exibe-a. Hoje em dia, o servidor provavelmente registra as localizações "
 "do usuário, já que não há nada que os proibida de fazê-lo. Essa vigilância "
 "não é intrinsecamente necessária, e seria possível evitá-las por meio de "
-"novo design: software livre/libre nos computadores do usuário poderia baixar "
+"novo design: software livre nos computadores do usuário poderia baixar "
 "os dados do mapa para as regiões pertinentes (se já não tiver baixado "
 "anteriormente), computar a rota, e exibi-la, sem repassar a ninguém onde o "
 "usuários está e aonde deseja ir."

@@ 839 - 866 @@

 msgid ""
 "Systems for borrowing bicycles, etc., can be designed so that the borrower's "
 "identity is known only inside the station where the item was borrowed.  "
 "Borrowing would inform all stations that the item is &ldquo;out,&rdquo; so "
 "when the user returns it at any station (in general, a different one), that "
 "station will know where and when that item was borrowed.  It will inform the "
 "other station that the item is no longer &ldquo;out.&rdquo; It will also "
 "calculate the user's bill, and send it (after waiting some random number of "
 "minutes) to headquarters along a ring of stations, so that headquarters "
 "would not find out which station the bill came from.  Once this is done, the "
 "return station would forget all about the transaction.  If an item remains "
 "&ldquo;out&rdquo; for too long, the station where it was borrowed can inform "
 "headquarters; in that case, it could send the borrower's identity "
 "immediately."
 msgstr ""
-"Sistemas para aluguel de bicicletas, etc. poderiam ser projetados de forma "
+"Sistemas para aluguel de bicicletas, etc., poderiam ser projetados de forma "
 "que a identidade do locatário seja conhecida apenas dentro da estação onde o "
 "item é alugado. Aluguel informaria todas as estações que o item está “fora”, "
 "de forma que quando o usuário retorna-a em qualquer estação (em geral, uma "
-"diferente), aquela estação saberá onde e quanto o item foi alugado. Esta "
+"diferente), aquela estação saberá onde e quando o item foi alugado. Esta "
 "informará às outras estações que o item não mais está “fora”. Esta também "
 "calculará a conta do usuário e a enviará (após esperar por um número "
 "aleatório de minutos) para a central dentre uma rede de estações, de forma "
 "que a central não saberia de qual estação a conta veio. Uma vez que isso é "
 "feito, a estação de retorno esqueceria a transação. Se um item permanece "
 "“fora” por muito tempo, a estação de onde ela foi alugada poderia informar à "
 "central; neste caso, ela poderia enviar a identidade do locatário "
 "imediatamente."
 
@@ 873 - 897 @@

 msgid ""
 "Internet service providers and telephone companies keep extensive data on "
 "their users' contacts (browsing, phone calls, etc).  With mobile phones, "
 "they also <a href=\"http://www.zeit.de/digital/datenschutz/2011-03/data-"
 "protection-malte-spitz\">record the user's physical location</a>.  They keep "
 "these dossiers for a long time: over 30 years, in the case of AT&amp;T.  "
 "Soon they will even <a href=\"http://www.wired.com/opinion/2013/10/the-"
 "trojan-horse-of-the-latest-iphone-with-the-m7-coprocessor-we-all-become-qs-"
 "activity-trackers/\">record the user's body activities</a>.  It appears that "
 "the <a href=\"https://www.aclu.org/blog/national-security-technology-and-"
 "liberty/it-sure-sounds-nsa-tracking-your-location\">NSA collects cell phone "
 "location data</a> in bulk."
 msgstr ""
 "Provedores de serviços de Internet e de telefone mantém dados extensivos de "
 "seus contatos de usuários (navegação, chamadas telefônicas etc.). Com "
 "telefones móveis, eles também <a href=\"http://www.zeit.de/digital/"
 "datenschutz/2011-03/data-protection-malte-spitz\">registram a localização "
 "física do usuário</a>. Eles mantêm esses dossiês por um longo período de "
-"tempo: cerca de 30 anos, no caso da AT&amp;T. Em breve, elas vão até mesmo "
+"tempo: cerca de 30 anos, no caso da AT&T. Em breve, elas vão até mesmo "
 "<a href=\"http://www.wired.com/opinion/2013/10/the-trojan-horse-of-the-"
 "latest-iphone-with-the-m7-coprocessor-we-all-become-qs-activity-trackers/"
 "\">registrar as atividades corporais do usuário</a>. Parece que a <a href="
 "\"https://www.aclu.org/blog/national-security-technology-and-liberty/it-sure-"
 "sounds-nsa-tracking-your-location\">NSA coleta dados da localização de "
 "telefone celular</a> em massa."
 
@@ 900 - 909 @@

 msgid ""
 "Unmonitored communication is impossible where systems create such dossiers.  "
 "So it should be illegal to create or keep them.  ISPs and phone companies "
 "must not be allowed to keep this information for very long, in the absence "
 "of a court order to surveil a certain party."
 msgstr ""
 "Comunicação não monitorada é impossível quando os sistemas criam tais "
-"dossiês. Então, deveria ser ilegal criá-los ou mantê-los. ISPs e empresas de "
+"dossiês. Então, deveria ser ilegal criá-los ou mantê-los. ISPs (Provedores de Serviço de Internet) e empresas de "
-"telefonia devem não ser permitidas de manter essa informação por muito "
+"telefonia não devem ser permitidas de manter essa informação por muito "
 "tempo, na ausência de uma ordem judicial para vigiar uma determinada pessoa."

@@ 912 - 933 @@

 msgid ""
 "This solution is not entirely satisfactory, because it won't physically stop "
 "the government from collecting all the information immediately as it is "
 "generated&mdash;which is what the <a href=\"http://www.guardian.co.uk/"
 "world/2013/jun/06/nsa-phone-records-verizon-court-order\">U.S. does with "
 "some or all phone companies</a>.  We would have to rely on prohibiting that "
 "by law.  However, that would be better than the current situation, where the "
 "relevant law (the PAT RIOT Act) does not clearly prohibit the practice.  In "
 "addition, if the government did resume this sort of surveillance, it would "
 "not get data about everyone's phone calls made prior to that time."
 msgstr ""
 "Essa solução não é inteiramente satisfatória, pois ela não vai impedir "
-"fisicamente o governo de coletar todas as informações imediatamente, pois "
+"fisicamente o governo de coletar todas as informações imediatamente, enquanto "
 "elas são geradas — que é o que os <a href=\"http://www.guardian.co.uk/"
 "world/2013/jun/06/nsa-phone-records-verizon-court-order\">EUA fazem com "
 "algumas ou todas empresas de telefonia</a>. Nós teríamos que confiar na "
 "proibição disto por lei. Porém, isso seria melhor do que a situação atual, "
 "na qual a lei relevante (A <i>USA PAT RIOT Act</i><sup><a href="
 "\"#TransNote5\">5</a></sup>) não proíbe claramente a prática. Além disso, se "
 "o governo voltasse a utilizar este tipo de vigilância, não conseguiria obter "
 "dados de todo mundo sobre as chamadas telefônicas feitas anteriormente a "
 "este período."

@@ 1003 @@

 msgid ""
 ...
 "police-edition\">their use of force fell by 60%</a>.  The ACLU is in favor "
 "of this."
 msgstr ""
 ...
-"police-edition\">eles seu uso de força caiu em 60%</a>;. A ACLU concorda com "
+"police-edition\">eles seu uso de força caiu em 60%</a>;. A ACLU (União Americana de Liberdades Civis) concorda com "
 "isto."
 
@@ 1007 - 1026 @@

 msgid ""
 "<a href=\"http://action.citizen.org/p/dia/action3/common/public/?"
 "action_KEY=12266\">Corporations are not people, and not entitled to human "
 "rights</a>.  It is legitimate to require businesses to publish the details "
 "of processes that might cause chemical, biological, nuclear, fiscal, "
 "computational (e.g., <a href=\"http://DefectiveByDesign.org\">DRM</a>) or "
 "political (e.g., lobbying) hazards to society, to whatever level is needed "
 "for public well-being.  The danger of these operations (consider the BP oil "
 "spill, the Fukushima meltdowns, and the 2008 fiscal crisis) dwarfs that of "
 "terrorism."
 msgstr ""
 "<a href=\"http://action.citizen.org/p/dia/action3/common/public/?"
 "action_KEY=12266\">Empresas não são pessoas, e a elas não se aplicam diretos "
 "humanos</a>. É legítimo requerer que negócios publiquem os detalhes dos "
-"processo que podem causar desastres químicos, biológicos, nucleares, "
+"processo que podem causar perigos químicos, biológicos, nucleares, "
 "fiscais, computacionais (ex.: <a href=\"http://DefectiveByDesign.org\">DRM</"
-"a>) ou político (ex.: <i>lobby</i>) para a sociedade, seja qual for o nível "
+"a>) ou políticos (ex.: <i>lobby</i>) para a sociedade, seja qual for o nível "
 "necessário para o bem público. O perigo dessas operações (considerando o "
 "vazamento de óleo da petroleira BP, colapsos de Fukushima e as crises "
 "fiscais em 2008) superam o terrorismo."
 
@@ 1037 - 1050 @@

 msgid ""
 "Digital technology has brought about a tremendous increase in the level of "
 "surveillance of our movements, actions, and communications.  It is far more "
 "than we experienced in the 1990s, and <a href=\"https://hbr.org/2013/06/your-"
 "iphone-works-for-the-secret-police\">far more than people behind the Iron "
 "Curtain experienced</a> in the 1980s, and proposed legal limits on state use "
 "of the accumulated data would not alter that."
 msgstr ""
 "Tecnologia digital trouxe um aumento tremendo no nível de vigilância de "
 "nossos movimentos, ações e comunicações. Ela é muito maior do que nós "
-"experimentamos nos anos 90s, e <a href=\"https://hbr.org/2013/06/your-iphone-"
+"experimentamos nos anos 90, e <a href=\"https://hbr.org/2013/06/your-iphone-"
 "works-for-the-secret-police\">muito mais do que as pessoas por traz da "
-"Cortina de Ferro experimentaram</a> nos anos 80s, e os limites legais "
+"Cortina de Ferro experimentaram</a> nos anos 80, e os limites legais "
 "propostos para o uso do Estado dos dados acumulados em nada alterariam."

@@ 1069 - 1078 @@

 msgid ""
 "Unless we believe that our free countries previously suffered from a grave "
 "surveillance deficit, and ought to be surveilled more than the Soviet Union "
 "and East Germany were, we must reverse this increase.  That requires "
 "stopping the accumulation of big data about people."
 msgstr ""
 "A menos que nós acreditemos que nossos países livres anteriormente sofreram "
 "de um grave deficit de vigilância, e deveria ser mais vigiado do que a União "
-"Soviética e a Alemanha Ocidental eram, nós devemos voltar para aumentar. "
+"Soviética e a Alemanha Ocidental eram, nós devemos reverter esse crescimento. "
 "Isso requer parar a acumulação de grandes dados sobre as pessoas."

@@ 1182 - 1186 @@

 msgid "*GNUN-SLOT: TRANSLATOR'S CREDITS*"
 msgstr ""
 "Traduzido por: Rafael Fontenelle <a href=\"mailto:rafaelff@gnome.org\">&lt;"
 "rafaelff@gnome.org&gt;</a><br />Revisado por: Paulo Francisco Slomp <a href="
-"\"mailto:slomp@ufrgs.br\">&lt;slomp@ufrgs.br&gt;</a>"
+"\"mailto:slomp@ufrgs.br\">&lt;slomp@ufrgs.br&gt;</a> e André Phellip Ferreira "
+"<a href=\"mailto:werewolf@cyberdude.com\">&lt;email@andrephellip.com&gt;</a>"