diff --git a/philosophy/surveillance-vs-democracy.pt-br.po b/philosophy/surveillance-vs-democracy.pt-br.po
index 0d5e755..4443791 100644
--- a/philosophy/surveillance-vs-democracy.pt-br.po
+++ b/philosophy/surveillance-vs-democracy.pt-br.po
@@ -1,15 +1,16 @@
 # Brazilian Portuguese translation of http://www.gnu.org/philosophy/surveillance-vs-democracy.html
 # Copyright (C) 2017 Free Software Foundation, Inc.
 # This file is distributed under the same license as the original article.
-# Rafael Fontenelle <rafaelff@gnome.org>, 2016, 2017.
+# Rafael Fontenelle <rafaelff@gnome.org>, 2016-2018.
 # Paulo Francisco Slomp <slomp@ufrgs.br>, 2016. (proofread)
 # Daniel Pimentel <d4n1@d4n1.org>, 2017. (proofread)
 # André Phellip Ferreira <werewolf@cyberdude.com>, 2017. (proofread)
 msgid ""
 msgstr ""
 "Project-Id-Version: surveillance-vs-democracy.html\n"
-"POT-Creation-Date: 2018-01-13 15:55+0000\n"
-"PO-Revision-Date: 2017-12-29 18:45-0200\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2018-01-30 14:26+0000\n"
+"PO-Revision-Date: 2018-02-10 21:14-0200\n"
 "Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
 "Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
@@ -18,6 +19,7 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 "X-Generator: Virtaal 1.0.0-beta1\n"
+"X-Outdated-Since: 2018-01-01 05:59+0000\n"
 
 #. type: Content of: <title>
 msgid ""
@@ -247,6 +249,13 @@ msgid ""
 "a>.  These rules are not seriously meant to be obeyed; rather, they are a "
 "fairy-tale we can believe if we like."
 msgstr ""
+"Na prática, não podemos nem mesmo esperar que as agências estaduais criem  "
+"desculpas para satisfazer as regras para o uso de dados de vigilância "
+"&ndash; porque as agências dos EUA já <a href=\"https://theintercept."
+"com/2018/01/09/dark-side-fbi-dea-illegal-searches-secret-evidence/\"> "
+"mentiram para encobrir a quebra das regras</a>. Essas regras não são "
+"seriamente feitas para serem obedecidas; em vez disso, eles são um conto de "
+"fadas que podemos acreditar se quisermos."
 
 #. type: Content of: <div><div><p>
 msgid ""
@@ -297,17 +306,26 @@ msgid ""
 "prohibited.  Once the data has been accumulated and the state has the "
 "possibility of access to it, it can misuse that data in dreadful ways, as "
 "shown by examples from <a href=\"http://falkvinge.net/2012/03/17/collected-"
-"personal-data-will-always-be-used-against-the-citizens/\">Europe</a> and <a "
-"href=\"https://en.wikipedia.org/wiki/Japanese_American_internment\">the US </"
-"a>."
+"personal-data-will-always-be-used-against-the-citizens/\">Europe</a>, <a "
+"href=\"https://en.wikipedia.org/wiki/Japanese_American_internment\">the US</"
+"a>, and most recently <a href=\"http://www.cbc.ca/news/world/terrifying-how-"
+"a-single-line-of-computer-code-put-thousands-of-innocent-turks-in-"
+"jail-1.4495021\">Turkey</a>.  (Turkey's confusion about who had really used "
+"the Bylock program only exacerbated the basic deliberate injustice of "
+"arbitrarily punishing people for having used it.)"
 msgstr ""
-"Dados de vigilância serão sempre usados para outros propósitos, ainda que "
-"isto seja proibido. Uma vez que os dados foram acumulados e o Estado tem a "
-"possibilidade de acessá-los, ele pode fazer mal uso dos dados acumulados em "
-"formas terríveis, como mostram por exemplo a <a href=\"http://falkvinge."
+"Os dados de vigilância sempre serão usados para outros fins, ainda que isso "
+"seja proibido. Uma vez que os dados foram acumulados e o estado tem a "
+"possibilidade de acesso a eles, ele pode usar esses dados de maneira "
+"terrível, como mostrado por exemplos da <a href=\"http://falkvinge."
 "net/2012/03/17/collected-personal-data-will-always-be-used-against-the-"
-"citizens/\">Europa</a> e <a href=\"https://en.wikipedia.org/wiki/"
-"Japanese_American_internment\">os EUA</a>."
+"citizens/\">Europa</a>, <a href=\"https://en.wikipedia.org/wiki/"
+"Japanese_American_internment\">dos EUA</a> e, mais recentemente, <a href="
+"\"http://www.cbc.ca/news/world/terrifying-how-a-single-line-of-computer-code-"
+"put-thousands-of-innocent-turks-in-jail-1.4495021\">Turquia</a>. (A confusão "
+"da Turquia sobre quem realmente usou o programa Bylock só exacerbou a "
+"injustiça básica e deliberada de punir arbitrariamente as pessoas por terem "
+"usado.)"
 
 #. type: Content of: <div><div><p>
 msgid ""
@@ -445,20 +463,21 @@ msgstr ""
 
 #. type: Content of: <div><div><p>
 msgid ""
-"For privacy's sake, you must avoid nonfree software since, as a consequence "
-"of giving others control of your computing, it is <a href=\"/malware/"
-"proprietary-surveillance.html\">likely to spy on you</a>.  Avoid <a href=\"/"
-"philosophy/who-does-that-server-really-serve.html\">service as a software "
-"substitute</a>; in addition to giving others control of how your computing "
-"is done, it requires you to hand over all the pertinent data to the server."
+"For privacy's sake, you must avoid nonfree software; if you give control of "
+"your computer's operations to companies, they are <a href=\"/malware/"
+"proprietary-surveillance.html\">likely to make it spy on you</a>.  Avoid <a "
+"href=\"/philosophy/who-does-that-server-really-serve.html\">service as a "
+"software substitute</a>; in addition to giving others control of how your "
+"computing is done, it requires you to hand over all the pertinent data to "
+"the company's server."
 msgstr ""
-"Por uma questão de privacidade, você deve evitar softwares não livres já "
-"que, como uma consequência de dar a outros o controle de seu computador, "
-"isto <a href=\"/malware/proprietary-surveillance.html\">possibilita lhe "
+"Por uma questão de privacidade, você deve evitar softwares não livres; se "
+"você der controle das operações do seu computador para empresas, elas <a "
+"href=\"/malware/proprietary-surveillance.html\">provavelmente vão lhe "
 "espiar</a>. Evite <a href=\"/philosophy/who-does-that-server-really-serve."
 "html\">serviços como um substituto de softwares</a>; além de fornecer a "
 "outros o controle de seu computador, isso requer que você entregue todos os "
-"dados pertinentes do servidor."
+"dados pertinentes do servidor da empresa."
 
 #. type: Content of: <div><div><p>
 msgid ""
@@ -469,8 +488,8 @@ msgid ""
 "or phone contacts.  Don't tell a company such as Facebook anything about "
 "your friends that they might not wish to publish in a newspaper.  Better "
 "yet, don't be used by Facebook at all.  Reject communication systems that "
-"require users to give their real names, even if you are going to give yours, "
-"since they pressure other people to surrender their privacy."
+"require users to give their real names, even if you are happy to divulge "
+"yours, since they pressure other people to surrender their privacy."
 msgstr ""
 "Proteja a privacidade de seus amigos e conhecidos também. <a href=\"http://"
 "bits.blogs.nytimes.com/2014/05/21/in-cybersecurity-sometimes-the-weakest-"
@@ -479,8 +498,8 @@ msgstr ""
 "mail e de telefones. Não informe a uma empresa, como o Facebook, nada sobre "
 "seus amigos que eles podem não desejar ser divulgado em um jornal. Melhor "
 "ainda, não use o Facebook. Rejeite sistemas de comunicação que exigem que os "
-"usuários forneça seus nomes reais, mesmo se você vai informar o seu, já que "
-"eles pressionam outras pessoas a abrir mão de sua privacidade."
+"usuários forneça seus nomes reais, mesmo se você estiver feliz em divulgar o "
+"seu, já que eles pressionam outras pessoas a abrir mão de sua privacidade."
 
 #. type: Content of: <div><div><p>
 msgid ""
@@ -668,7 +687,7 @@ msgstr ""
 "extensão limitada que eles podem</a>, mas que pode apenas parcialmente "
 "compensar o dano que eles causam por coletar tais dados, em primeiro lugar. "
 "Adicionalmente, muitas dessas empresas fazem mau uso dos dados diretamente "
-"ou os fornecem para <i>data brokers“</i><sup><a href=\"#TransNote3\">3</a></"
+"ou os fornecem para <i>data brokers</i><sup><a href=\"#TransNote3\">3</a></"
 "sup>."
 
 #. type: Content of: <div><div><p>
@@ -703,7 +722,7 @@ msgstr ""
 "usuários e tendências. Isso converte um mero incômodo — propaganda que nós "
 "podemos aprender a ignorar — em um sistema de vigilância que nos prejudica, "
 "nós sabendo ou não. Compras pela Internet também rastreiam seus usuários. E "
-"todos nós estamos sabendo que ”políticas de privacidade“ são mais desculpas "
+"todos nós estamos sabendo que “políticas de privacidade” são mais desculpas "
 "para violação de privacidade do que compromisso de cumprimento."
 
 #. type: Content of: <div><div><p>
@@ -1120,16 +1139,16 @@ msgstr ""
 "<li id=\"TransNote5\">A explicação do espaço em branco em “PAT RIOT” foi "
 "dada por Richard Stallman em sua entrevista em 12 de novembro de 2012 a "
 "Hacker Public Radio (Ver <a href=\"/philosophy/speeches-and-interview.html"
-"\">Discursos e Entrevistas</a>). Exatamente aos 1h 13' 40“, ele deixou "
-"registrado o motivo pelo qual não se pode chamar tal ato de ”Ato "
-"Patriótico“ (USA Patriot): o título completo do Ato em questão é <i>Uniting "
+"\">Discursos e Entrevistas</a>). Exatamente aos 1h 13' 40\", ele deixou "
+"registrado o motivo pelo qual não se pode chamar tal ato de “Ato "
+"Patriótico” (USA Patriot): o título completo do Ato em questão é <i>Uniting "
 "and Strengthening America by Providing Appropriate Tools Required to "
 "Intercept and Obstruct Terrorism Act</i> (em português, ato de união e "
 "fortalecimento fornecendo ferramentas necessárias e apropriadas para "
-"interceptar e obstruir terrorismo), abreviada sob o acrônimo ”USAPATRIOT "
-"Act“; por se tratar de um acrônimo, temos todo o direito de dividir entre P."
+"interceptar e obstruir terrorismo), abreviada sob o acrônimo “USAPATRIOT "
+"Act”; por se tratar de um acrônimo, temos todo o direito de dividir entre P."
 "A.T. e R.I.O.T., o que muda a pronúncia e evita a referência a patriotismo. "
-"Acrescentando que, <i>riot</i> significa ”revolta“ e <i>Pat riot</i> faz "
+"Acrescentando que, <i>riot</i> significa “revolta” e <i>Pat riot</i> faz "
 "referência ao grito da torcida da equipe de futebol americano de Boston, os "
 "<i>Pats</i>.</li>\n"
 "</ol>"
@@ -1149,6 +1168,9 @@ msgstr ""
 "sugestões podem ser enviadas para <a href=\"mailto:webmasters@gnu.org\">&lt;"
 "webmasters@gnu.org&gt;</a>."
 
+#
+#
+#
 #
 #.  TRANSLATORS: Ignore the original text in this paragraph,
 #.         replace it with the translation of these two:
@@ -1176,11 +1198,8 @@ msgstr ""
 "envio de traduções das páginas desse site."
 
 #. type: Content of: <div><p>
-# | Copyright &copy; 2015, 2016, [-2017-] {+2017, 2018+} Richard Stallman
-#, fuzzy
-#| msgid "Copyright &copy; 2015, 2016, 2017 Richard Stallman"
 msgid "Copyright &copy; 2015, 2016, 2017, 2018 Richard Stallman"
-msgstr "Copyright &copy; 2015, 2016, 2017 Richard Stallman"
+msgstr "Copyright &copy; 2015, 2016, 2017, 2018 Richard Stallman"
 
 #. type: Content of: <div><p>
 msgid ""
@@ -1205,3 +1224,60 @@ msgstr ""
 #. type: Content of: <div><p>
 msgid "Updated:"
 msgstr "Última atualização: "
+
+#~ msgid ""
+#~ "Surveillance data will always be used for other purposes, even if this is "
+#~ "prohibited.  Once the data has been accumulated and the state has the "
+#~ "possibility of access to it, it can misuse that data in dreadful ways, as "
+#~ "shown by examples from <a href=\"http://falkvinge.net/2012/03/17/"
+#~ "collected-personal-data-will-always-be-used-against-the-citizens/"
+#~ "\">Europe</a> and <a href=\"https://en.wikipedia.org/wiki/"
+#~ "Japanese_American_internment\">the US </a>."
+#~ msgstr ""
+#~ "Dados de vigilância serão sempre usados para outros propósitos, ainda que "
+#~ "isto seja proibido. Uma vez que os dados foram acumulados e o Estado tem "
+#~ "a possibilidade de acessá-los, ele pode fazer mal uso dos dados "
+#~ "acumulados em formas terríveis, como mostram por exemplo a <a href="
+#~ "\"http://falkvinge.net/2012/03/17/collected-personal-data-will-always-be-"
+#~ "used-against-the-citizens/\">Europa</a> e <a href=\"https://en.wikipedia."
+#~ "org/wiki/Japanese_American_internment\">os EUA</a>."
+
+#~ msgid ""
+#~ "For privacy's sake, you must avoid nonfree software since, as a "
+#~ "consequence of giving others control of your computing, it is <a href=\"/"
+#~ "malware/proprietary-surveillance.html\">likely to spy on you</a>.  Avoid "
+#~ "<a href=\"/philosophy/who-does-that-server-really-serve.html\">service as "
+#~ "a software substitute</a>; in addition to giving others control of how "
+#~ "your computing is done, it requires you to hand over all the pertinent "
+#~ "data to the server."
+#~ msgstr ""
+#~ "Por uma questão de privacidade, você deve evitar softwares não livres já "
+#~ "que, como uma consequência de dar a outros o controle de seu computador, "
+#~ "isto <a href=\"/malware/proprietary-surveillance.html\">possibilita lhe "
+#~ "espiar</a>. Evite <a href=\"/philosophy/who-does-that-server-really-serve."
+#~ "html\">serviços como um substituto de softwares</a>; além de fornecer a "
+#~ "outros o controle de seu computador, isso requer que você entregue todos "
+#~ "os dados pertinentes do servidor."
+
+#~ msgid ""
+#~ "Protect your friends' and acquaintances' privacy, too.  <a href=\"http://"
+#~ "bits.blogs.nytimes.com/2014/05/21/in-cybersecurity-sometimes-the-weakest-"
+#~ "link-is-a-family-member/\">Don't give out their personal information</a> "
+#~ "except how to contact them, and never give any web site your list of "
+#~ "email or phone contacts.  Don't tell a company such as Facebook anything "
+#~ "about your friends that they might not wish to publish in a newspaper.  "
+#~ "Better yet, don't be used by Facebook at all.  Reject communication "
+#~ "systems that require users to give their real names, even if you are "
+#~ "going to give yours, since they pressure other people to surrender their "
+#~ "privacy."
+#~ msgstr ""
+#~ "Proteja a privacidade de seus amigos e conhecidos também. <a href="
+#~ "\"http://bits.blogs.nytimes.com/2014/05/21/in-cybersecurity-sometimes-the-"
+#~ "weakest-link-is-a-family-member/\">Não forneça informação pessoal deles</"
+#~ "a>, exceto como contatá-los, e nunca forneça a qualquer site sua lista de "
+#~ "contatos de e-mail e de telefones. Não informe a uma empresa, como o "
+#~ "Facebook, nada sobre seus amigos que eles podem não desejar ser divulgado "
+#~ "em um jornal. Melhor ainda, não use o Facebook. Rejeite sistemas de "
+#~ "comunicação que exigem que os usuários forneça seus nomes reais, mesmo se "
+#~ "você vai informar o seu, já que eles pressionam outras pessoas a abrir "
+#~ "mão de sua privacidade."